<?php
namespace Estoque\Logic\RecalculoEstoque\Exceptions;
/**
 * Created by JetBrains PhpStorm.
 * User: maximiliansilva
 * Date: 21/01/13
 * Time: 16:59
 * To change this template use File | Settings | File Templates.
 */
use \Geral\Util\AcumuladorDeMensagens;
class RecalculoExceptions extends \Estoque\Logic\Exception
{
    private $messageName;


    public function __construct($messagemName){
        parent::__construct($messagemName);
        $this->messageName = $messagemName;
    }

    public function getMessageName()
    {
        return $this->messageName;
    }

    public static function produtoInicialMenorIgualFinal(){
        AcumuladorDeMensagens::getInstance()->addMensagem('msg_produto_inicial_final');
        return false;
    }

    public static function informarProdutoInicial(){
        AcumuladorDeMensagens::getInstance()->addMensagem('msg_produto_inicial_informado');
        return false;
    }

    public static function informarProdutoFinal(){
        AcumuladorDeMensagens::getInstance()->addMensagem('msg_produto_final_informado');
        return false;
    }

    public static function informarData(){
        AcumuladorDeMensagens::getInstance()->addMensagem('pla00600_informe_data');
        return false;
    }

    public static function localizacaoNaoCadastradaAlmoxarifado(){
        AcumuladorDeMensagens::getInstance()->addMensagem('local_estoque_nao_cadastrado');
        return false;
    }

    public static function almoxarifadoNaoCadastradoFilial(){
        AcumuladorDeMensagens::getInstance()->addMensagem('almoxarifado_nao_cadastrado');
        return false;
    }

    public static function almoxarifadoNaoHabilitadoOperador(){
        AcumuladorDeMensagens::getInstance()->addMensagem('msg_almox_n_hab_op');
        return false;
    }

    public static function localizacaoNaoHabilitadaOperador(){
        AcumuladorDeMensagens::getInstance()->addMensagem('msg_localizacao_nao_habilitada_operador');
        return false;
    }

//    public static function exemploParams($param){
//        AcumuladorDeMensagens::getInstance()->addMensagem('msg_', array($param));
//        throw new self(AcumuladorDeMensagens::ID_ACUMULADOR_DE_MENSAGENS);
//    }
}
