<?php
namespace Geral\Repositories;

class Subgrupprod extends \Doctrine\ORM\EntityRepository
{

    /**
     * Deleta o registro que possui as chaves passadas por parâmetro.
     * Se o último parâmetro for omitido, deleta todos os subgrupos do grupo.
     *
     * @param String $nrorg       Organização
     * @param String $cdgrupprod  Grupo
     * @param String $cdsubgrprod Subgrupo
     *
     * @return null
     * @throws \Exception
     */
    public static function deletaRegistro (
        $nrorg, $cdgrupprod, $cdsubgrprod = 'A'
    ) {
        $sql = <<<SQL
        DELETE FROM SUBGRUPPROD
        WHERE NRORG        = :NRORG
          AND CDGRUPPROD   = :CDGRUPPROD
          AND (CDSUBGRPROD = :CDSUBGRPROD
           OR :CDSUBGRPROD   = 'A')
SQL;

        $params = array(
            'NRORG'       => $nrorg,
            'CDGRUPPROD'  => $cdgrupprod,
            'CDSUBGRPROD' => $cdsubgrprod
        );

        try{
            return \Setforms2\Shared\Connection::getInstance()->execute($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }

    }

}