<?php

require_once 'base/FpaHomologmagnetEntityBase.php';

/**
 * This class has been auto-generated by Setforms
 * 
 * @package Entity
 * 
 * @author  alessandrobartels
 */
class FpaHomologmagnetEntity extends FpaHomologmagnetEntityBase
{

    // Retorna todos os registros
    public function retornaRegistros(TkDateTime $mesCompetencia, $nrOrg){
        return FpaHomologmagnet::retornaRegistros($mesCompetencia, $nrOrg);
    }


    // Criar metodo para procurar o registro na lista
    public function inicializaListaRegistros($mesCompetencia, $nrOrg){
        $resultados = FpaHomologmagnet::retornaRegistros($mesCompetencia, $nrOrg);
        if (is_array($resultados) === true) {
            foreach ($resultados as $resultado) {
                $this->addItem($resultado, $resultado->getNrhomologmagnet());
            }

            return true;
        } else {
            return false;
        }
    }


    public function insereRegistroLista(
        $nrOrg, $mesCompetencia, $idAtivo, $idTpRegistro, $nrTpInscricao, $nrInscricao, $dsLinha, $nrTpInscricaoTom = 0,
        $nrInscricaoTom = 0, $nrPisPasep = 0, $dtRescisao = null, $nrVinculo = null
    ){

        $item = new self();

        $item->setNrorg($nrOrg);
        $item->setMescompetencia($mesCompetencia);
        $item->setIdtpinscestrutu($nrTpInscricao);
        $item->setCdinscestrut($nrInscricao);
        $item->setIdtpinscesttoma($nrTpInscricaoTom);
        $item->setCdinscestrutoma($nrInscricaoTom);
        $item->setNrpispaseppes($nrPisPasep);
        $item->setDtrescisaovinc($dtRescisao);
        $item->setIdtiporegistro($idTpRegistro);
        $item->setDslinharegistro($dsLinha);
        $item->setNrvinculom($nrVinculo);
        $item->setIdativo($idAtivo);

        $this->addItem($item);

    }


    public function procuraRegistroLista($nrInscricao, $nrInscricaoTom, $nrRegistro) {
        $itens = $this->getItems();
        foreach ($itens as $key => $item) {
            if (($item->getCdinscestrut() === $nrInscricao)
                && ($item->getCdinscestrutoma() === $nrInscricaoTom)
                && ($item->getIdtiporegistro() === $nrRegistro)
            ) {
                return $key;
            }
        }

        return false;
    }

    /**
     * Remove todos os registros da Org. no mes de competencia.
     *
     * @param integer $nrOrg          Numero da Organizacao.
     * @param string  $mesCompetencia Mes de competencia.
     *
     * @return void
     *
     * @author alessandrobartels - 04/01/2012
     */
    public function retroceder($nrOrg, $mesCompetencia){
        $registros = $this->retornaRegistros($mesCompetencia, $nrOrg);
        if (count($registros) > 0) {
            foreach ($registros as $registro) {
                $this->addItem($registro);
                $this->removeItem($registro);
            }

            $this->persist();
        }
    }

}

