/* Sistemas Integrados TECNISA

Nome: 00NF_CDPTRGS_DTULTATU_ETAPAPROD.SQL

Descrio:

Atualiza a data de ultima atualizao da tabela ETAPAPROD

Criao:
07/05/2007 Ronald Reis
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_ETAPAPROD' and
            type = 'TR'                    and
            u.uid = o.uid                  and
            u.name = USER)
  DROP TRIGGER DTULTATU_ETAPAPROD
  GO

CREATE TRIGGER DTULTATU_ETAPAPROD
ON ETAPAPROD
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'ETAPAPROD', '', 'CDETAPAPROD=' + CDETAPAPROD+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE ETAPAPROD
      SET  DTULTATUETPR = GETDATE()
      FROM INSERTED
      WHERE ISNULL(ETAPAPROD.CDETAPAPROD,0) = ISNULL(INSERTED.CDETAPAPROD,0);
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_ETAPAPROD','4.11.134';
GO
