import {
  Http, IEventParam, DateHelper, Metadata,
} from '@zeedhi/core';
import {
  AlertService, Form, Modal, ModalService,
} from '@zeedhi/common';

export class Dfs48000SaidaDoOperadorLogisticoController {
  private gerarDocumentoModal!: Modal;

  public readOnlySubGrup: boolean = true;

  public readOnlyRota: boolean = true;

  public readOnlyDestPed: boolean = true;

  public readOnlyLote: boolean = true;

  public filterValueCDFILIOPELOG: any = {};

  public filterValueCDROTATRANS: Array<any> = [];

  public filterValueCDSUBGRPPROD: Array<any> = [];

  public filterValueCDFILIALDEST: Array<any> = [];

  public filterValueCDLOTENVIOL: Array<any> = [];

  public filterValuePEDOLEXTR: string | string[] = '';

  public filterValueVERIFICACNPJ: any = 'Desconsidera';

  public filterValueDTENTREGA: any = {};

  public filterValueSTATUS: string | string[] = '';

  public filterValueDATAENT: any = 'Data de Entrega';

  public filterGridFormulario: any = {};

  public filterGridFormularioProduto: any = {};

  public filterGridLancamentoGerado: any = {};

  public filterValueNRINSJUREMPR: any = {};

  public periodDisabled: boolean = true;

  public swtDisabled: boolean = false;

  public adqEmpresa: any = {};

  public async createGerarDocumenoModal() {
    this.gerarDocumentoModal = await ModalService.createFromJson('pages/dfs48000/dfs4800Saida_do_opl_gerar_documento', true);
  }

  public destroyGerarDocumentoModal() {
    this.gerarDocumentoModal?.destroy();
  }

  public openModalGerarDocumento() {
    this.gerarDocumentoModal.show();
  }

  public onChangeSwitchRota({ component }: IEventParam<any>) {
    if (this.readOnlyRota) {
      this.filterValueCDROTATRANS = [];
      component.parent.children.forEach((child: { name: any; value: any; }) => {
        if (child.name === 'CDROTATRANS') {
          child.value = [];
        }
      });
    }
  }

  public onChangeSwitchSubGrup({ component }: IEventParam<any>) {
    if (this.readOnlySubGrup) {
      this.filterValueCDSUBGRPPROD = [];
      component.parent.children.forEach((child: { name: any; value: any; }) => {
        if (child.name === 'CDSUBGRPROD') {
          child.value = [];
        }
      });
    }
  }

  public onChangeSwitchDestPed({ component }: IEventParam<any>) {
    if (this.readOnlyDestPed) {
      this.filterValueCDFILIALDEST = [];
      component.parent.children.forEach((child: { name: any; value: any; }) => {
        if (child.name === 'CDFILIALDEST') {
          child.value = 'T';
        }
      });
    }
  }

  public onChangeSwitchLote({ component }: IEventParam<any>) {
    if (this.readOnlyLote) {
      this.filterValueCDLOTENVIOL = [];
      component.parent.children.forEach((child: { name: any; value: any; }) => {
        if (child.name === 'CDLOTENVIOL') {
          child.value = [];
        }
      });
    }
  }

  public onChangeLote() {
    this.swtDisabled = true;
  }

  public onChangeFieldFilialOL({ component }: any) {
    this.filterValueCDFILIOPELOG = component.value;
    const fielddest = component.parent.childrenInstances.filter((field: any) => field.name.includes('CDFILIALDEST'))[0];
    fielddest.datasource.filter.P_CDFILIOPELOG = component.value.CDFILIAL;
    fielddest.datasource.get();
  }

  public onChangeFieldRotaOL({ component }: any) {
    this.filterValueCDROTATRANS = component.value;
  }

  public onChangeFieldSubgrupoOL({ component }: any) {
    this.filterValueCDSUBGRPPROD = component.value;
  }

  public onChangeFieldFilialDestOL({ component }: any) {
    this.filterValueCDFILIALDEST = component.value;
  }

  public onChangeFieldLoteOL({ component }: any) {
    this.filterValueCDLOTENVIOL = component.value;
  }

  public onChangeFieldStatusPedidoOL({ component }: any) {
    this.filterValuePEDOLEXTR = component.value;
  }

  public onChangeFieldDTEntOL({ component }: any) {
    this.filterValueDATAENT = component.value;
  }

  public onChangeFieldStatusPedOL({ component }: any) {
    this.filterValueSTATUS = component.id;
  }

  public onChangeFieldInscrDestOL({ component }: any) {
    this.filterValueVERIFICACNPJ = component.value;
  }

  public onChangeFieldDataEntOL({ component }: any) {
    this.filterValueDTENTREGA = component.value;
    // const itemsText = component.value;
    // component.parent.getChildInstance('selected-value').text = `selected value: ${itemsText}`;
  }

  public onFilterSaidaOpen({ component }: any) {
    const filterButton = document.getElementById('gridSaidasOPL_filterButton');
    filterButton?.click();
    this.filterValueCDFILIOPELOG = component.getColumn('CDFILIOPELOG');
    this.filterValueCDROTATRANS = component.getColumn('CDROTATRANS');
    this.filterValueCDSUBGRPPROD = component.getColumn('CDSUBGRPROD');
    this.filterValueCDFILIALDEST = component.getColumn('CDFILIALDEST');
    this.filterValueCDLOTENVIOL = component.getColumn('CDLOTENVIOL');
    this.filterValuePEDOLEXTR = component.getColumn('PEDOLEXTR');
    this.filterValueSTATUS = component.getColumn('IDSTATUS');
    this.filterValueVERIFICACNPJ = component.getColumn('VERIFICACNPJ');
    this.filterValueDATAENT = component.getColumn('DATAENT');
    this.filterValueDTENTREGA = DateHelper.getValue('TODAY', 'DD-MM-YYYY');
  }

  public formater(array: Array<any>) {
    // let result = '_';
    // array.forEach((value: any) => result.concat() value.concat('_'));
    return array.length !== 0 ? String('_').concat(array.join('_').concat(String('_'))) : 'T';
  }

  public formaterLote(array: Array<any>) {
    // let result = '_';
    // array.forEach((value: any) => result.concat() value.concat('_'));
    return array.length !== 0 ? String('_').concat(array.join('_').concat(String('_'))) : 'N';
  }

  public async getInfo(datasourcefilter: string) {
    return Http.get(datasourcefilter);
  }

  public async onFilterload() {
    const grid = Metadata.getInstance<any>('gridSaidasOPL');
    const arrayCDFILIDEST = typeof grid.datasource.dynamicFilter.CDFILIALDEST !== 'undefined' ? grid.datasource.dynamicFilter.CDFILIALDEST[0].value.map((f: any) => f.CDFILIAL) : [];
    const arrayCDSUBGRPPROD = typeof grid.datasource.dynamicFilter.CDSUBGRPPROD !== 'undefined' ? grid.datasource.dynamicFilter.CDSUBGRPPROD[0].value.map((f: any) => f.CDSUBGRPPROD) : [];
    const arrayCDROTATRANS = typeof grid.datasource.dynamicFilter.CDROTATRANS !== 'undefined' ? grid.datasource.dynamicFilter.CDROTATRANS[0].value.map((f: any) => f.CDROTATRANS) : [];
    const arrayCDLOTENVIOL = typeof grid.datasource.dynamicFilter.CDLOTENVIOL !== 'undefined' ? grid.datasource.dynamicFilter.CDLOTENVIOL[0].value.map((f: any) => f.CDLOTENVIOL) : [];
    // const arrayIDSTATUS = [];
    const nrinsjDatasource = '/crudN/dfs48000adqEmpresa?in=CDFILIOPELOG&CDFILIOPELOG='.concat(this.filterValueCDFILIOPELOG.CDFILIAL);
    
    this.filterValueNRINSJUREMPR = await this.getInfo(nrinsjDatasource);
    
    const filterFilial = {
      P_CDLOTENVIOL: this.formaterLote(arrayCDLOTENVIOL),
      P_PEDOLEXTR: null,
      P_NRINSJUREMPR: this.filterValueNRINSJUREMPR.data.data[0].NRINSJUREMPR,
      P_DATAENT: this.filterValueDATAENT.value,
      P_DTENTREGA: this.filterValueDTENTREGA,
      P_FILOPELOG: grid.datasource.dynamicFilter.CDFILIOPELOG[0].value.CDFILIAL,
      P_CDFILIAL: this.formater(arrayCDFILIDEST),
      P_ROTA: this.formater(arrayCDROTATRANS),
      P_FILCLIE: 'L',
      P_SUBGRUPO: this.formater(arrayCDSUBGRPPROD),
      P_VERIFICACNPJ: this.filterValueVERIFICACNPJ,
      P_CDCLIENTE: null,
      P_STATUS: '9_1_2_0',
    };
    grid.datasource.filter = filterFilial;
    grid.datasource.get();
  }

  public loadGridFormulario({ component }: any) {
    component.datasource.route = '/crudN/dfs48000_gridSaidaOplFormulario';

    component.datasource.filter = this.filterGridFormulario;
    component.datasource.get();
  }

  public loadGridFormularioProduto({ component }: any) {
    component.datasource.route = '/crudN/dfs48000_gridSaidaOplFormularioProduto';

    component.datasource.filter = this.filterGridFormularioProduto;
    component.datasource.get();
  }

  public loadGridLancamentoGerado({ component }: any) {
    component.datasource.route = '/crudN/dfs48000_gridSaidaOplLancamentoGerado';

    component.datasource.filter = this.filterGridLancamentoGerado;
    component.datasource.get();
  }

  public onChangeCdfiliOl({ component }: IEventParam<any>) {
    const fieldValueDestino = component.parent.getElementById('CDFILIALDEST');

    fieldValueDestino.datasource.filter.P_CDFILIOPELOG = component.value.CDFILIAL;

    fieldValueDestino.datasource.get();
  }

  public abrirModalGerarDocumento() {
    this.gerarDocumentoModal.show();
  }

  public fecharModalGerarDocumento() {
    this.gerarDocumentoModal.hide();
  }

  public async onModalGerarDocumentoAddOpen({ component }: IEventParam<any>) {
    const field = component.getChildInstance('CDFILIOPELOG');

    await field.setValue(this.filterValueCDFILIOPELOG.CDFILIAL);
  }

  public async salvarModalGerarDocumento() {
    const form = Metadata.getInstance<Form>('formModalGerarDocumentoAdd');
    const valid = form.validate();
    const arrayCDFILIAL: Array<any> = [];
    let valueCDFILIAL: String = '';

    if (form.value.CDFILIAL.length > 0) {
      form.value.CDFILIAL.forEach((val: any) => {
        arrayCDFILIAL.push(val.CDFILIAL);
      });
      valueCDFILIAL = String('_').concat(arrayCDFILIAL.join('_').concat(String('_')));
    } else {
      valueCDFILIAL = 'T';
    }

    if (!valid) {
      AlertService.show({
        top: true,
        right: true,
        timeout: 2000,
        name: 'invalidoAltert',
        text: 'Preencha todos os campos obrigatórios!',
        color: 'error',
      });
    } else {
      form.submit();

      const row = {
        CDFILIOPELOG: form.value.CDFILIOPELOG.CDFILIAL,
        CDFILDEST: valueCDFILIAL,
        CDTIPOOPER: form.value.CDTIPOOPER,
        DATA: form.value.DATA,
        NMRAZSOCTRAN: form.value.NMRAZSOCTRAN.NMRAZSOCTRAN,
        FRETE: form.value.FRETE.FRETE,
        NRPLACA: form.value.NRPLACA.NRPLACA,
        SGUFVEICULO: form.value.SGUFVEICULO.SGUFVEICULO,
      };

      await Http.post('/', { requestType: 'Row', row }).then((response) => {
        if (response.data.error !== undefined) {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'errorAlert',
            text: 'Não foi possível concluir o processo!<br>Por favor entre em contato com o Suporte Teknisa!',
            color: 'error',
          });
        } else if (response.data.dataset.data.P_ERROS === 'N') {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'successAlert',
            text: 'Processo concluído com sucesso!',
            color: 'success',
          });

          this.fecharModalGerarDocumento();
        } else {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'errorAlert',
            text: 'Não foi possível concluir o processo!<br>Não há dados!',
            color: 'error',
          });
        }
      });
    }
  }
}
